#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/stat.h>
#include <string>
#include <vector>
using namespace std;
string home_dir = getenv("HOME");
string icon_dir = home_dir + "/.icons";
string cur_dir = icon_dir;
GtkWidget* hbox = NULL;
GtkWidget* image = NULL;
GtkWidget* combo = NULL;
GtkWidget* win = NULL;
GtkWidget* checkbox = NULL;

bool restart_x = false;

void combo_changed(GtkComboBox* widget, gpointer user_data)
{
    gtk_container_remove(GTK_CONTAINER(hbox), image);

    cur_dir = icon_dir + "/";
    cur_dir += gtk_combo_box_get_active_text(widget);
    cur_dir += "/cursors";

    printf("%s\n", cur_dir.c_str());
    chdir(cur_dir.c_str());

    system("xcur2png -d /tmp/pcs1234 left_ptr");
    chdir("/tmp/pcs1234");

    image = gtk_image_new_from_file("left_ptr_000.png");
    gtk_container_add(GTK_CONTAINER(hbox), image);
    gtk_widget_show(image);

    system("rm *");
    chdir(cur_dir.c_str());
    system("rm *.conf");

}

void ok_button_clicked(GtkButton *button, gpointer user_data)
{
    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbox)))
        restart_x = true;

    chdir(icon_dir.c_str());
    system("rm default");
    symlink(gtk_combo_box_get_active_text(GTK_COMBO_BOX(combo)), "default");

    gtk_widget_destroy(win);
}

int main (int argc, char *argv[])
{
    vector<string> themes;

    struct dirent *entry;		//This structure will hold file information
	struct stat file_status;	//This structure will be used to query file status
	DIR *dir = opendir(cur_dir.c_str());	//This pointer references the directory stream

	//Change directory to the given path
	chdir(cur_dir.c_str());

	//Loop through all files and directories
	while ( (entry = readdir(dir)) != NULL) {
		//Don't bother with the .. and . directories
		if ((strcmp(entry->d_name, ".") != 0) && (strcmp(entry->d_name, "..") != 0)) {
			//Get the status info for the current file
			if (stat(entry->d_name, &file_status) == 0) {
				//Is this a directory, or a file?
				if (S_ISDIR(file_status.st_mode)) {
					//Call countfiles again (recursion) and add the result to the count total
					themes.push_back(entry->d_name);
				}
				else {
					//We've found a file, increment the count
//					count++;
				}
			}
		}
	}

    sort(themes.begin(), themes.end());

    vector<string>::iterator iter = themes.begin();

    while(iter != themes.end())
    {
        printf("%s\n", (*iter).c_str());
        iter++;
    }

    char cur_theme[128];
    readlink((icon_dir + "/default").c_str(), cur_theme, 128);

    printf("%s\n", cur_theme);

    system("mkdir -p /tmp/pcs1234");

    GtkWidget* vbox = NULL;
    GtkWidget* frame = NULL;
    GtkWidget* button_ok = NULL;
    GtkWidget* button_cancel = NULL;
    GtkWidget* hbox_buttons = NULL;

    /* Initialize GTK+ */
    g_log_set_handler ("Gtk", G_LOG_LEVEL_WARNING, (GLogFunc) gtk_false, NULL);
    gtk_init (&argc, &argv);
    g_log_set_handler ("Gtk", G_LOG_LEVEL_WARNING, g_log_default_handler, NULL);

    /* Create the main window */
    win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_container_set_border_width (GTK_CONTAINER (win), 8);
    gtk_window_set_title (GTK_WINDOW (win), "Puppy Cursor Selector");
    gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_CENTER);
    gtk_widget_realize (win);
    g_signal_connect (win, "destroy", gtk_main_quit, NULL);

    vbox = gtk_vbox_new(FALSE, 5);
    gtk_container_set_border_width(GTK_CONTAINER (vbox), 5);
    gtk_container_add(GTK_CONTAINER (win), vbox);
    gtk_widget_show(vbox);

    combo = gtk_combo_box_new_text();

    iter = themes.begin();

    while(iter != themes.end())
    {
        gtk_combo_box_append_text(GTK_COMBO_BOX(combo), (*iter).c_str());
        iter++;
    }
    gtk_combo_box_set_active(GTK_COMBO_BOX(combo), 0);

    gtk_container_add(GTK_CONTAINER(vbox), combo);
    gtk_widget_show(combo);
    g_signal_connect (GTK_COMBO_BOX(combo), "changed", G_CALLBACK(combo_changed), NULL);

    //Preview frame
    frame = gtk_frame_new("Preview");
    gtk_container_add(GTK_CONTAINER (vbox), frame);
    gtk_widget_show (frame);

    //Hbox for preview images
    hbox = gtk_hbox_new(FALSE, 1);
    gtk_container_add(GTK_CONTAINER (frame), hbox);
    gtk_widget_show (hbox);

    checkbox = gtk_check_button_new_with_label("Restart X when OK is pressed?");
    gtk_container_add(GTK_CONTAINER(vbox), checkbox);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), TRUE);
    gtk_widget_show (checkbox);

    hbox_buttons = gtk_hbox_new(FALSE, 10);
    gtk_container_add(GTK_CONTAINER(vbox), hbox_buttons);
    gtk_widget_show(hbox_buttons);

    button_ok = gtk_button_new_from_stock(GTK_STOCK_OK);
    gtk_container_add(GTK_CONTAINER(hbox_buttons), button_ok);
    gtk_widget_show(button_ok);
    g_signal_connect(GTK_BUTTON(button_ok), "clicked", G_CALLBACK(ok_button_clicked), NULL);

    button_cancel = gtk_button_new_from_stock(GTK_STOCK_CANCEL);
    gtk_container_add(GTK_CONTAINER(hbox_buttons), button_cancel);
    gtk_widget_show(button_cancel);
    g_signal_connect (GTK_BUTTON(button_cancel), "clicked", gtk_main_quit, NULL);

    /* Enter the main loop */
    gtk_widget_show_all (win);
    gtk_main ();

    system("rm -fr /tmp/pcs1234");

    if(restart_x)
        system("restartwm");

    return 0;
}
